## Shark.tar.gz

=== CMakeLists.txt ===
#####################################################################
#       Shark Machine Learning Library                              #
#       Top-Level CMake driver file                                 #
#       Optionally included sub-probjects:                          #
#         * Test/CMakeLists.txt                                     #
#         * examples/CMakeLists.txt                                 #
#         * doc/CMakeLists.txt                                      #
#####################################################################
PROJECT( shark CXX )

CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
CMAKE_POLICY(SET CMP0003 NEW)
ENABLE_TESTING()

SET( EXECUTABLE_OUTPUT_PATH bin )
SET( LIBRARY_OUTPUT_PATH lib )

ENABLE_LANGUAGE(C) # Fix small issue with OpenMP on some platforms/versions

#####################################################################
#                       Dynamic or static                           #
#####################################################################

OPTION( OPT_DYNAMIC_LIBRARY
	"Compile shark into a dynamic library instead of a static one."
    OFF
)

IF( OPT_DYNAMIC_LIBRARY )
    set(Boost_USE_STATIC_LIBS OFF)
    add_definitions(-DBOOST_TEST_DYN_LINK)
ELSE( OPT_DYNAMIC_LIBRARY )
    set(Boost_USE_STATIC_LIBS ON)
    SET( LIBRARY_FLAGS STATIC )
ENDIF( OPT_DYNAMIC_LIBRARY )

IF ( OPT_DYNAMIC_LIBRARY )
    SET( LIBRARY_FLAGS "SHARED" ${LIBRARY_FLAGS})
ELSE ( OPT_DYNAMIC_LIBRARY )
    SET( LIBRARY_FLAGS "STATIC" ${LIBRARY_FLAGS})
ENDIF ( OPT_DYNAMIC_LIBRARY )

#####################################################################
#		Official Releases are tagged.                       #
#####################################################################
OPTION( OPT_OFFICIAL_RELEASE "Is this an official Shark release." OFF )

IF( OPT_OFFICIAL_RELEASE )
	ADD_DEFINITIONS( -DSHARK_OFFICIAL_RELEASE )
ENDIF( OPT_OFFICIAL_RELEASE )

#####################################################################
#		Marks the official version                          #
#####################################################################
SET( SHARK_VERSION_MAJOR 3 )
SET( SHARK_VERSION_MINOR 0 )
SET( SHARK_VERSION_PATCH 0 )
set(SHARK_VERSION
  ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.${SHARK_VERSION_PATCH})

ADD_DEFINITIONS(
 -DSHARK_VERSION_MAJOR=${SHARK_VERSION_MAJOR}
 -DSHARK_VERSION_MINOR=${SHARK_VERSION_MINOR}
 -DSHARK_VERSION_PATCH=${SHARK_VERSION_PATCH}
)

CONFIGURE_FILE (
  "${CMAKE_CURRENT_SOURCE_DIR}/include/shark/Core/Shark.h.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/include/shark/Core/Shark.h"
  )

#####################################################################
#	Adjustments for cpack and deb package generation            #
#####################################################################
SET( CPACK_PACKAGE_NAME "libshark-i386" )
SET( CPACK_BUNDLE_NAME "libshark" )
SET( CPACK_PACKAGE_VENDOR "Institut fur Neuroinformatik, Ruhr-Universitaet Bochum" )
SET( CPACK_PACKAGE_VERSION_MAJOR ${SHARK_VERSION_MAJOR} )
SET( CPACK_PACKAGE_VERSION_MINOR ${SHARK_VERSION_MINOR} )
SET( CPACK_PACKAGE_VERSION_PATCH ${SHARK_VERSION_PATCH} )
SET( CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/gpl-3.0.txt )

if (UNIX AND NOT WIN32)
 if (CMAKE_SIZEOF_VOID_P MATCHES "8")
   SET( CPACK_PACKAGE_NAME "libshark-x86_64" )
   SET( CPACK_DEBIAN_PACKAGE_NAME libshark-x86-64 )
   SET( CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64 )
 else (CMAKE_SIZEOF_VOID_P MATCHES "8")
   SET( CPACK_PACKAGE_NAME "libshark-i386" )
   SET( CPACK_DEBIAN_PACKAGE_NAME libshark-i386 )
   SET( CPACK_DEBIAN_PACKAGE_ARCHITECTURE i386 )
 endif (CMAKE_SIZEOF_VOID_P MATCHES "8")
endif (UNIX AND NOT WIN32)

SET( CPACK_DEBIAN_PACKAGE_VERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.${SHARK_VERSION_PATCH} )

SET( CPACK_DEBIAN_PACKAGE_DESCRIPTION
     "SHARK is a modular C++ library for the design and optimization of adaptive systems. It provides methods for linear and nonlinear optimization, in particular evolutionary and gradient-based algorithms, kernel-based learning algorithms and neural networks, and various other machine learning techniques. SHARK serves as a toolbox to support real world applications as well as research indifferent domains of computational intelligence and machine learning. The sources are compatible with the following platforms: Windows, Solaris, MacOS X, and Linux."
)
# SET( CPACK_DEBIAN_PACKAGE_DEPENDS ... )
# SET( DEBIAN_PACKAGE_BUILDS_DEPENDS ... )
SET( CPACK_DEBIAN_PACKAGE_MAINTAINER "Christian Igel <c.igel@ieee.org>" )

#####################################################################
#    Adjust include, lib, example and doc paths for installation    #
#####################################################################
IF( UNIX )
	SET( SHARK_INSTALL_INCLUDE_DIR include/ )
	SET( SHARK_INSTALL_LIB_DIR lib/ )
	SET( SHARK_INSTALL_CONTRIB_DIR share/shark/contrib/ )
	SET( SHARK_INSTALL_EXAMPLE_DIR share/shark/examples/ )
	SET( SHARK_INSTALL_DOC_DIR share/shark/doc/ )
ELSE( UNIX )
	SET( SHARK_INSTALL_INCLUDE_DIR include/shark/ )
	SET( SHARK_INSTALL_LIB_DIR lib/ )
	SET( SHARK_INSTALL_CONTRIB_DIR contrib/ )
	SET( SHARK_INSTALL_EXAMPLE_DIR examples/ )
	SET( SHARK_INSTALL_DOC_DIR doc )
ENDIF( UNIX )

#####################################################################
#           Enable installer and package generation	            #
#####################################################################
INCLUDE( CPack )

#####################################################################
#           Explicit macro setup for debug configuration	    #
#####################################################################
# enable or disable debugging, default is Release
IF(NOT CMAKE_BUILD_TYPE)
       SET(CMAKE_BUILD_TYPE "Release")
ENDIF(NOT CMAKE_BUILD_TYPE)
IF((CMAKE_BUILD_TYPE MATCHES "debug") OR (CMAKE_BUILD_TYPE MATCHES "DEBUG"))
	SET(CMAKE_BUILD_TYPE "Debug")
ENDIF((CMAKE_BUILD_TYPE MATCHES "debug") OR (CMAKE_BUILD_TYPE MATCHES "DEBUG"))
IF((CMAKE_BUILD_TYPE MATCHES "release") OR (CMAKE_BUILD_TYPE MATCHES "RELEASE"))
	SET(CMAKE_BUILD_TYPE "Release")
ENDIF((CMAKE_BUILD_TYPE MATCHES "release") OR (CMAKE_BUILD_TYPE MATCHES "RELEASE"))

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
	ADD_DEFINITIONS(-DDEBUG )
	ADD_DEFINITIONS("-DBOOST_UBLAS_TYPE_CHECK=0" )
	#we want to be warned in debug mode
	IF(UNIX)
		IF(CMAKE_COMPILER_IS_GNUCC)
			ADD_DEFINITIONS(-Wall)
		ENDIF(CMAKE_COMPILER_IS_GNUCC)
	ENDIF(UNIX)
ENDIF (CMAKE_BUILD_TYPE MATCHES "Debug")
IF(CMAKE_BUILD_TYPE MATCHES "Release")
	ADD_DEFINITIONS(-DNDEBUG )
	ADD_DEFINITIONS(-DBOOST_UBLAS_NDEBUG )
ENDIF (CMAKE_BUILD_TYPE MATCHES "Release")

#####################################################################
#           Report compilers	                                    #
#####################################################################
message(STATUS "C++ compiler: " ${CMAKE_CXX_COMPILER})
message(STATUS "C compiler: " ${CMAKE_C_COMPILER})

#####################################################################
#           Boost configuration	                                    #
#####################################################################
SET(Boost_USE_MULTITHREADED ON)
ADD_DEFINITIONS( -DBOOST_PARAMETER_MAX_ARITY=15 -DBOOST_FILESYSTEM_VERSION=3 )
FIND_PACKAGE( Boost 1.45.0 COMPONENTS system date_time filesystem program_options regex signals serialization thread unit_test_framework REQUIRED )

include_directories ( ${Boost_INCLUDE_DIRS} )
IF( WIN32 )
	link_directories( ${Boost_LIBRARY_DIRS} )
ELSE( WIN32 )
	FIND_LIBRARY( PTHREAD_LIBRARY pthread )
	SET( LINK_LIBRARIES
		${Boost_LIBRARIES}
		${PTHREAD_LIBRARY}
	)
ENDIF( WIN32 )

#####################################################################
#		Optionally enable OpenMP                            #
#####################################################################
OPTION( OPT_ENABLE_OPENMP "Enable OpenMP if available." OFF )

IF( OPT_ENABLE_OPENMP )
	FIND_PACKAGE( OpenMP QUIET )

	IF( OPENMP_FOUND )
		MESSAGE( STATUS "OpenMP...found" )
		ADD_DEFINITIONS( -DSHARK_USE_OPENMP )
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
	ELSE( OPENMP_FOUND )
		MESSAGE( WARNING "OpenMP...not found" )
	ENDIF( OPENMP_FOUND )
ENDIF( OPT_ENABLE_OPENMP )

#####################################################################
#           HDF5 configuration                                      #
#####################################################################
#FIND_PACKAGE(HDF5 COMPONENTS C CXX HL QUIET)
#IF( HDF5_FOUND )
#    MESSAGE(STATUS "HDF5...found")
#    INCLUDE_DIRECTORIES( ${HDF5_INCLUDE_DIRS} )
#    IF( WIN32 )
#        LINK_DIRECTORIES( ${HDF5_LIBRARY_DIRS} )
#    ELSE( WIN32 )
#        SET(LINK_LIBRARIES ${LINK_LIBRARIES} ${HDF5_LIBRARIES} )
#    ENDIF( WIN32 )
#ELSE( HDF5_FOUND )
#    MESSAGE(STATUS "HDF5 not found, skip")
#ENDIF( HDF5_FOUND )

#####################################################################
#           ATLAS configuration	                                    #
#####################################################################
OPTION( OPT_ENABLE_ATLAS "Use ATLAS as Linear Algebra Library" OFF )
IF ( OPT_ENABLE_ATLAS )
	find_library(CBLAS_LIBRARY
		cblas
		HINTS
		${ATLAS_ROOT}/lib
	)
	find_library(CLAPACK_LIBRARY
		lapack
		HINTS
		${ATLAS_ROOT}/lib
	)
	find_library(ATLAS_LIBRARY
		atlas
		HINTS
		${ATLAS_ROOT}/lib
	)

	get_filename_component(ATLAS_PATH @CBLAS_LIBRARY@ PATH )
	SET (ATLAS_PATH ${ATLAS_PATH}/.. )
	mark_as_advanced(
		CBLAS_LIBRARY
		CLAPACK_LIBRARY
		ATLAS_LIBRARY
	)
	IF ( CBLAS_LIBRARY )
		message(STATUS "ATLAS found....true")
		SET(LINK_LIBRARIES ${LINK_LIBRARIES} ${CLAPACK_LIBRARY} )
		SET(LINK_LIBRARIES ${LINK_LIBRARIES} ${CBLAS_LIBRARY} )
		SET(LINK_LIBRARIES ${LINK_LIBRARIES} ${ATLAS_LIBRARY} )
		ADD_DEFINITIONS( -DSHARK_USE_ATLAS )
		include_directories ( ${ATLAS_ROOT}/include/ ${ATLAS_ROOT}/include/atlas/ )
	ELSE ( CBLAS_LIBRARY )
		message(STATUS "ATLAS found....false")
	ENDIF ( CBLAS_LIBRARY )
ENDIF ( OPT_ENABLE_ATLAS )

#####################################################################
#                       Static Code Analysis                        #
#####################################################################
IF( UNIX )
    FIND_PROGRAM( CPP_CHECK cppcheck )
    IF( CPP_CHECK )
    	MESSAGE(STATUS "cppcheck available for static code analysis." )
    	ADD_CUSTOM_TARGET(
		code_analysis
		${CPP_CHECK} --enable=all --xml --force -I${CMAKE_CURRENT_SOURCE_DIR}/include ${CMAKE_CURRENT_SOURCE_DIR} 2> StaticAnalysis.xml
	)
    ENDIF( CPP_CHECK )
ENDIF( UNIX )

#####################################################################
#                Adjust compiler flags and settings for MSVC							#
#####################################################################
IF( MSVC )
    message(STATUS "Win32")
	SET( DISABLE_WARNINGS "/wd4250 /wd4251 /wd4275 /wd4800 /wd4308" )
	#4250: inherit via dominance
	#4251: needs to have dll-interface
	#4275: non-dll interface used as base for dll-interface class
	#4308: Negative integral constant
	SET( ADDITIONAL_COMPILER_FLAGS "${DISABLE_WARNINGS}" )

	STRING( REPLACE "/O2" "/Od" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}" )

	SET( CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${ADDITIONAL_COMPILER_FLAGS}" )
	SET( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${ADDITIONAL_COMPILER_FLAGS}" )
	SET( CMAKE_CXX_FLAGS_MINSIZERELEASE "${CMAKE_CXX_FLAGS_MINSIZERELEASE} ${ADDITIONAL_COMPILER_FLAGS}" CACHE STRING "compiler-flags" FORCE )
	SET( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${ADDITIONAL_COMPILER_FLAGS}" CACHE STRING "compiler-flags" FORCE )

	SET( CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}" CACHE STRING "compiler-flags" FORCE )

=== Test/CMakeLists.txt ===
#####################################################################
#       Shark Machine Learning Library                              #
#       Setup for unit testing                                      #
#       Test invocation: CTest                                      #
#       Test implementation: Boost UTF                              #
#####################################################################

#####################################################################
#       Configure logging of test restuls to XML                    #
#####################################################################
OPTION( OPT_LOG_TEST_OUTPUT "Log test output to XML files." OFF )

#####################################################################
#   Adds a unit test for the shark library                          #
#   Param: SRC Source files for compilation                         #
#   Param: NAME Target name for the resulting executable            #
#   Output: Executable in ${SHARK}/Test/bin                         #
#                                                                   #
#       If OPT_LOG_TEST_OUTPUT is enabled, test log is written      #
#   to ${NAME_Log.xml} in ${SHARK}/Test/bin.                        #
#####################################################################
MACRO( SHARK_ADD_TEST SRC NAME)

    IF( OPT_LOG_TEST_OUTPUT )
        SET( XML_LOGGING_COMMAND_LINE_ARGS "--log_level=test_suite --log_format=XML --log_sink=${NAME}_Log.xml --report_level=no" )
    ENDIF( OPT_LOG_TEST_OUTPUT )

    ADD_EXECUTABLE( ${NAME}
        ${SRC}
        Models/derivativeTestHelper.h
    )

    SET( LINK_LIBRARIES
        shark
        ${Boost_LIBRARIES}
    )

    TARGET_LINK_LIBRARIES( ${NAME} ${LINK_LIBRARIES} )

    ADD_TEST( ${NAME} ${EXECUTABLE_OUTPUT_PATH}/${NAME} ${XML_LOGGING_COMMAND_LINE_ARGS} )
ENDMACRO()

#LinAlg Tests
SHARK_ADD_TEST( LinAlg/DiagonalMatrix.cpp LinAlg_DiagonalMatrix)
SHARK_ADD_TEST( LinAlg/sumRows.cpp LinAlg_SumRows)
SHARK_ADD_TEST( LinAlg/Proxy.cpp LinAlg_Proxy )
SHARK_ADD_TEST( LinAlg/repeat.cpp LinAlg_Repeat)
SHARK_ADD_TEST( LinAlg/covar_corrcoef.cpp LinAlg_covar_corrcoef )
SHARK_ADD_TEST( LinAlg/rotations.cpp LinAlg_rotations )
SHARK_ADD_TEST( LinAlg/permute.cpp LinAlg_Permutations )
SHARK_ADD_TEST( LinAlg/Metrics.cpp LinAlg_Metrics)
SHARK_ADD_TEST( LinAlg/RQ.cpp LinAlg_RQ )
SHARK_ADD_TEST( LinAlg/detsymm.cpp LinAlg_detsymm )
SHARK_ADD_TEST( LinAlg/dlmin.cpp LinAlg_dlmin )
SHARK_ADD_TEST( LinAlg/eigenerr.cpp LinAlg_eigenerr )
SHARK_ADD_TEST( LinAlg/eigensort.cpp LinAlg_eigensort )
SHARK_ADD_TEST( LinAlg/eigensymm.cpp LinAlg_eigensymm )
SHARK_ADD_TEST( LinAlg/eigensymmJacobi2.cpp LinAlg_eigensymmJacobi2 )
SHARK_ADD_TEST( LinAlg/eigensymmjacobi.cpp LinAlg_eigensymmjacobi )
SHARK_ADD_TEST( LinAlg/fft.cpp LinAlg_fft )
SHARK_ADD_TEST( LinAlg/g_inverse.cpp LinAlg_g_inverse )#todo: more tests
SHARK_ADD_TEST( LinAlg/linmin.cpp LinAlg_linmin )
SHARK_ADD_TEST( LinAlg/lnrsrch.cpp LinAlg_lnrsrch )
SHARK_ADD_TEST( LinAlg/rank.cpp LinAlg_rank )
SHARK_ADD_TEST( LinAlg/rank_decomp.cpp LinAlg_rank_decomp )
SHARK_ADD_TEST( LinAlg/VectorStatistics.cpp LinAlg_VectorStatistics )
SHARK_ADD_TEST( LinAlg/svd.cpp LinAlg_svd )
SHARK_ADD_TEST( LinAlg/svdrank.cpp LinAlg_svdrank )
SHARK_ADD_TEST( LinAlg/svdsort.cpp LinAlg_svdsort )
SHARK_ADD_TEST( LinAlg/choleskyDecomposition.cpp LinAlg_choleskyDecomposition)
SHARK_ADD_TEST( LinAlg/invertSymmPositiveDefinite.cpp LinAlg_invertSymmPositiveDefinite)
SHARK_ADD_TEST( LinAlg/solve.cpp LinAlg_solve)
SHARK_ADD_TEST( LinAlg/VectorTransformations.cpp LinAlg_VectorTransformations)
SHARK_ADD_TEST( LinAlg/Initialize.cpp LinAlg_Initialize)
SHARK_ADD_TEST( LinAlg/fast_prod.cpp LinAlg_FastProd)
SHARK_ADD_TEST( LinAlg/BlockOperations.cpp LinAlg_BlockOperations)
#Operator tests
SHARK_ADD_TEST( Algorithms/DirectSearch/Operators/Selection/Selection.cpp DirectSearch_Selection )
SHARK_ADD_TEST( Algorithms/DirectSearch/Operators/Recombination/Recombination.cpp DirectSearch_Recombination )
SHARK_ADD_TEST( Algorithms/DirectSearch/Operators/Mutation/BitflipMutation.cpp DirectSearch_BitflipMutation )

#Algorithms tests 
#Direct Search
SHARK_ADD_TEST( Algorithms/DirectSearch/CMA.cpp DirectSearch_CMA )
SHARK_ADD_TEST( Algorithms/DirectSearch/CMSA.cpp DirectSearch_CMSA )
SHARK_ADD_TEST( Algorithms/DirectSearch/ElitistCMA.cpp DirectSearch_ElitistCMA )
SHARK_ADD_TEST( Algorithms/DirectSearch/OnePlusOneES.cpp DirectSearch_OnePlusOneES )
SHARK_ADD_TEST( Algorithms/DirectSearch/MOCMA.cpp DirectSearch_MOCMA )
SHARK_ADD_TEST( Algorithms/DirectSearch/SteadyStateMOCMA.cpp DirectSearch_SteadyStateMOCMA )
SHARK_ADD_TEST( Algorithms/DirectSearch/Algorithms.cpp Algorithms_DirectSearch )
#GradientDescent
SHARK_ADD_TEST( Algorithms/GradientDescent/BFGS.cpp GradDesc_BFGS )
SHARK_ADD_TEST( Algorithms/GradientDescent/LBFGS.cpp GradDesc_LBFGS )
SHARK_ADD_TEST( Algorithms/GradientDescent/CG.cpp GradDesc_CG )
SHARK_ADD_TEST( Algorithms/GradientDescent/IRLS.cpp GradDesc_IRLS )
SHARK_ADD_TEST( Algorithms/GradientDescent/Rprop.cpp GradDesc_Rprop )
SHARK_ADD_TEST( Algorithms/GradientDescent/NoisyRprop.cpp GradDesc_NoisyRprop )
SHARK_ADD_TEST( Algorithms/GradientDescent/Quickprop.cpp GradDesc_Quickprop )
SHARK_ADD_TEST( Algorithms/GradientDescent/SteepestDescent.cpp GradDesc_SteepestDescent )
#LP - Linear Programs
SHARK_ADD_TEST( Algorithms/LP/LinearProgram.cpp LP_LinearProgram )
#QP - Quadratic Programs
SHARK_ADD_TEST( Algorithms/QP/LRUCache.cpp QP_LRUCache )
SHARK_ADD_TEST( Algorithms/QP/KernelMatrix.cpp QP_KernelMatrix )

#Trainers
SHARK_ADD_TEST( Algorithms/Trainers/CSvmTrainer.cpp Trainers_CSvmTrainer )
SHARK_ADD_TEST( Algorithms/Trainers/FisherLDA.cpp Trainers_FisherLDA )
SHARK_ADD_TEST( Algorithms/Trainers/KernelMeanClassifier.cpp Trainers_KernelMeanClassifier )
SHARK_ADD_TEST( Algorithms/Trainers/EpsilonSvmTrainer.cpp Trainers_EpsilonSvmTrainer )
SHARK_ADD_TEST( Algorithms/Trainers/OneClassSvmTrainer.cpp Trainers_OneClassSvmTrainer )
SHARK_ADD_TEST( Algorithms/Trainers/RegularizationNetworkTrainer.cpp Trainers_RegularizationNetworkTrainer )
SHARK_ADD_TEST( Algorithms/Trainers/LDA.cpp Trainers_LDA )
SHARK_ADD_TEST( Algorithms/Trainers/LinearRegression.cpp Trainers_LinearRegression )
SHARK_ADD_TEST( Algorithms/Trainers/McSvmTrainer.cpp Trainers_McSvmTrainer )
SHARK_ADD_TEST( Algorithms/Trainers/LinearSvmTrainer.cpp Trainers_LinearSvmTrainer )
SHARK_ADD_TEST( Algorithms/Trainers/NBClassifierTrainerTests.cpp Trainers_NBClassifier )
SHARK_ADD_TEST( Algorithms/Trainers/Normalization.cpp Trainers_Normalization )
SHARK_ADD_TEST( Algorithms/Trainers/KernelNormalization.cpp Trainers_KernelNormalization )
SHARK_ADD_TEST( Algorithms/Trainers/SigmoidFit.cpp Trainers_SigmoidFit )
SHARK_ADD_TEST( Algorithms/Trainers/PCA.cpp Trainers_PCA )
SHARK_ADD_TEST( Algorithms/Trainers/Perceptron.cpp Trainers_Perceptron )
SHARK_ADD_TEST( Algorithms/Trainers/MissingFeatureSvmTrainerTests.cpp Trainers_MissingFeatureSvmTrainer )

#misc algorithms
SHARK_ADD_TEST( Algorithms/GridSearch.cpp Algorithms_GridSearch )
SHARK_ADD_TEST( Algorithms/Hypervolume.cpp Algorithms_Hypervolume )
SHARK_ADD_TEST( Algorithms/nearestneighbors.cpp Algorithms_NearestNeighbor )
SHARK_ADD_TEST( Algorithms/KMeans.cpp Algorithms_KMeans )
SHARK_ADD_TEST( Algorithms/JaakkolaHeuristic.cpp Algorithms_JaakkolaHeuristic )

SHARK_ADD_TEST( Fuzzy/FCL.cpp Fuzzy_Control_Language_Parser )
SHARK_ADD_TEST( Fuzzy/FuzzySets.cpp Fuzzy_FuzzySets )
SHARK_ADD_TEST( Fuzzy/LinguisticTerms.cpp Fuzzy_LinguisticTerms )
SHARK_ADD_TEST( Fuzzy/Mamdani.cpp Fuzzy_Mamdani )
#Models
SHARK_ADD_TEST( Models/ConcatenatedModel.cpp Models_ConcatenatedModel )
SHARK_ADD_TEST( Models/FFNet.cpp Models_FFNet )
SHARK_ADD_TEST( Models/LinearModel.cpp Models_LinearModel )
SHARK_ADD_TEST( Models/LinearNorm.cpp Models_LinearNorm )
SHARK_ADD_TEST( Models/NBClassifierTests.cpp Models_NBClassifier )
#SHARK_ADD_TEST( Models/OnlineRNNet.cpp Models_OnlineRNNet )
SHARK_ADD_TEST( Models/RBFNet.cpp Models_RBFNet ) 
SHARK_ADD_TEST( Models/RNNet.cpp Models_RNNet ) 
SHARK_ADD_TEST( Models/CMAC.cpp Models_CMAC )

SHARK_ADD_TEST( Models/SigmoidModel.cpp Models_SigmoidModel )
SHARK_ADD_TEST( Models/Softmax.cpp Models_Softmax )
SHARK_ADD_TEST( Models/SoftNearestNeighborClassifier.cpp Models_SoftNearestNeighborClassifier )
SHARK_ADD_TEST( Models/Kernels/KernelExpansion.cpp Models_KernelExpansion )
SHARK_ADD_TEST( Models/NearestNeighborRegression.cpp Models_NearestNeighborRegression )
SHARK_ADD_TEST( Models/OneVersusOneClassifier.cpp Models_OneVersusOneClassifier )

#Kernels


#SHARK_ADD_TEST( Models/Kernels/KernelFunction.cpp Models_KernelFunction )
SHARK_ADD_TEST( Models/Kernels/GaussianRbfKernel.cpp Models_GaussianKernel )
SHARK_ADD_TEST( Models/Kernels/LinearKernel.cpp Models_LinearKernel )
SHARK_ADD_TEST( Models/Kernels/MonomialKernel.cpp Models_MonomialKernel )
SHARK_ADD_TEST( Models/Kernels/PolynomialKernel.cpp Models_PolynomialKernel )
SHARK_ADD_TEST( Models/Kernels/ScaledKernel.cpp Models_ScaledKernel )
SHARK_ADD_TEST( Models/Kernels/WeightedSumKernel.cpp Models_WeightedSumKernel )
SHARK_ADD_TEST( Models/Kernels/ProductKernel.cpp Models_ProductKernel )
SHARK_ADD_TEST( Models/Kernels/ArdKernel.cpp Models_ArdKernel )
# SHARK_ADD_TEST( Models/Kernels/MklKernel.cpp Models_MklKernel )   # error with gcc 4.2.1
SHARK_ADD_TEST( Models/Kernels/SubrangeKernel.cpp Models_SubrangeKernel )
SHARK_ADD_TEST( Models/Kernels/DiscreteKernel.cpp Models_DiscreteKernel )
# SHARK_ADD_TEST( Models/Kernels/MultiTaskKernel.cpp Models_MultiTaskKernel )   # error with gcc 4.2.1

#KernelMethods
SHARK_ADD_TEST( Models/Kernels/KernelHelpers.cpp Models_KernelHelpers )
SHARK_ADD_TEST( Models/Kernels/KernelNearestNeighborClassifier.cpp Models_KernelNearestNeighborClassifier )
SHARK_ADD_TEST( Models/Kernels/KernelNearestNeighborRegression.cpp Models_KernelNearestNeighborRegression )
SHARK_ADD_TEST( Models/Kernels/EvalSkipMissingFeaturesTests.cpp Models_EvalSkipMissingFeatures )
SHARK_ADD_TEST( Models/Kernels/MissingFeaturesKernelExpansionTests.cpp Models_MissingFeaturesKernelExpansion )
SHARK_ADD_TEST( Models/Kernels/CSvmDerivative.cpp Models_CSvmDerivative )

#Trees
SHARK_ADD_TEST( Models/RFClassifier.cpp Models_RFClassifier )
SHARK_ADD_TEST( Models/CARTClassifier.cpp Models_CARTClassifier )

# Core tests
SHARK_ADD_TEST( Core/ScopedHandleTests.cpp ScopedHandleTests )

#Data Tests
SHARK_ADD_TEST( Data/Csv.cpp Data_Csv )
SHARK_ADD_TEST( Data/CVDatasetTools.cpp Data_CVDatasetTools )
SHARK_ADD_TEST( Data/Dataset.cpp Data_Dataset )
SHARK_ADD_TEST( Data/DataView.cpp Data_DataView )
IF (HDF5_FOUND)
    SHARK_ADD_TEST( Data/HDF5Tests.cpp Data_HDF5 )
ENDIF(HDF5_FOUND)
SHARK_ADD_TEST( Data/Libsvm.cpp Data_Libsvm )
# SHARK_ADD_TEST( Data/MKLBatchInterface.cpp Data_MKLBatchInterface )   # failes with gcc 4.2.1
SHARK_ADD_TEST( Data/PrecomputedMatrix.cpp Data_PrecomputedMatrix )

#Objective Functions
SHARK_ADD_TEST( ObjectiveFunctions/ErrorFunction.cpp ObjFunct_ErrorFunction )
SHARK_ADD_TEST( ObjectiveFunctions/SparseFFNetError.cpp ObjFunct_SparseFFNetError )
SHARK_ADD_TEST( ObjectiveFunctions/NoisyErrorFunction.cpp ObjFunct_NoisyErrorFunction )
SHARK_ADD_TEST( ObjectiveFunctions/CrossValidation.cpp ObjFunct_CrossValidation )
SHARK_ADD_TEST( ObjectiveFunctions/Benchmarks.cpp ObjFunct_Benchmarks )
SHARK_ADD_TEST( ObjectiveFunctions/KernelTargetAlignment.cpp ObjFunct_KernelTargetAlignment )
SHARK_ADD_TEST( ObjectiveFunctions/RadiusMarginQuotient.cpp ObjFunct_RadiusMarginQuotient )
SHARK_ADD_TEST( ObjectiveFunctions/LooError.cpp ObjFunct_LooError )
SHARK_ADD_TEST( ObjectiveFunctions/LooErrorCSvm.cpp ObjFunct_LooErrorCSvm )
SHARK_ADD_TEST( ObjectiveFunctions/SvmLogisticInterpretation.cpp ObjFunct_SvmLogisticInterpretation )

#Objective Functions/Loss
SHARK_ADD_TEST( ObjectiveFunctions/CrossEntropy.cpp ObjFunct_CrossEntropy )
SHARK_ADD_TEST( ObjectiveFunctions/DenoisingAutoencoderError.cpp ObjFunct_DenoisingAutoencoderError )
SHARK_ADD_TEST( ObjectiveFunctions/SquaredLoss.cpp ObjFunct_SquaredLoss )

=== doc/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )

find_package( Doxygen REQUIRED )
find_package( PythonInterp REQUIRED )

CONFIGURE_FILE (
  "${CMAKE_CURRENT_SOURCE_DIR}/Shark.dox.in"
  "${CMAKE_CURRENT_BINARY_DIR}/Shark.dox"
)

CONFIGURE_FILE (
  "${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages/conf.py.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages/conf.py"
)

set( SPHINX_EXECUTABLE sphinx-build )
set( SPHINX_PARAMETERS -b html )

add_custom_target( doc ALL
		   COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Shark.dox
		   COMMAND ${SPHINX_EXECUTABLE} ${SPHINX_PARAMETERS} ${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages ${CMAKE_CURRENT_BINARY_DIR}/sphinx_pages/build/html
)

OPTION( OPT_INSTALL_DOCUMENTATION "Install documentation." OFF )

IF( OPT_INSTALL_DOCUMENTATION )

INSTALL( FILES index.html
	DESTINATION ${SHARK_INSTALL_DOC_DIR}
)

INSTALL( DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doxygen_pages
	DESTINATION ${SHARK_INSTALL_DOC_DIR}
	PATTERN ".*" EXCLUDE
)

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doxygen_pages/css
	DESTINATION ${SHARK_INSTALL_DOC_DIR}/doxygen_pages
	PATTERN ".*" EXCLUDE
)

INSTALL( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/sphinx_pages
	DESTINATION ${SHARK_INSTALL_DOC_DIR}
	PATTERN ".*" EXCLUDE
)

ENDIF( OPT_INSTALL_DOCUMENTATION )

=== examples/CMakeLists.txt ===
#####################################################################
#		Shark Machine Learning Library
#		Setup for example compilation
#####################################################################

CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )
CMAKE_POLICY(SET CMP0003 NEW)

#####################################################################
#	Adds an example for the shark library
#	Param: SRC Source files for compilation
#	Param: NAME Target name for the resulting executable
#	Param: COMPONENT Installation dir, e.g., EA/MOO
#	Output: Executable in
#          * ${SHARK_INSTALL_EXAMPLE_DIR}
#            * ${COMPONENT}
#       If OPT_LOG_TEST_OUTPUT is enabled, test log is written
#	to ${NAME_Log.xml} in ${SHARK}/Test/bin.
#####################################################################
MACRO( SHARK_ADD_EXAMPLE SRC NAME COMPONENT )

	ADD_EXECUTABLE( ${NAME}
		${SRC}
	)

	SET( EXAMPLE_LIBRARIES
		${LINK_LIBRARIES}
		shark
        lrt
	)

	TARGET_LINK_LIBRARIES( ${NAME} ${EXAMPLE_LIBRARIES} )

	INSTALL( TARGETS ${NAME}
		RUNTIME DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/${COMPONENT}/
		COMPONENT EXAMPLES
	)

	INSTALL( FILES
		${SRC}
	 	DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/${COMPONENT}
		)

	SOURCE_GROUP( ${COMPONENT} FILES ${SRC} )
ENDMACRO()

SHARK_ADD_EXAMPLE( Core/Oracle.cpp Oracle "Core" )
SHARK_ADD_EXAMPLE( Core/Probe.cpp Probe "Core" )
SHARK_ADD_EXAMPLE( Core/Logger.cpp Logger "Logger" )

IF( OPT_ENABLE_NETWORKING )
    SHARK_ADD_EXAMPLE( Network/HttpServer.cpp HttpServer "Network")
    INSTALL( DIRECTORY
	     "${CMAKE_CURRENT_SOURCE_DIR}/Network/ext-4.0.2a"
	     DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Network
	     PATTERN ".*" EXCLUDE
    )
    INSTALL( DIRECTORY
	     "${CMAKE_CURRENT_SOURCE_DIR}/Network/js"
	     DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Network
	     PATTERN ".*" EXCLUDE
    )
   INSTALL( FILES
   	    "${CMAKE_CURRENT_SOURCE_DIR}/Network/groupgrid.html"
	    DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Network
	)

ENDIF( OPT_ENABLE_NETWORKING )

SHARK_ADD_EXAMPLE( EA/MOO/AdditiveEpsilonIndicatorMain.cpp AdditiveEpsilonIndicatorMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/ApproximatedHypervolumeMain.cpp ApproximatedHypervolumeMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/ExactHypervolumeMain.cpp ExactHypervolumeMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/BoundingBoxCalculatorMain.cpp BoundingBoxCalculatorMain "EA/MOO" )

SHARK_ADD_EXAMPLE( EA/MOO/AGE1Main.cpp AGE1Main "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/SMSEMOAMain.cpp SMSEMOAMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/SteadyStateMOCMAMain.cpp SteadyStateMOCMAMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/EpsilonSteadyStateMOCMAMain.cpp EpsilonSteadyStateMOCMAMain "EA/MOO" )
## SHARK_ADD_EXAMPLE( EA/MOO/LocalitySensitiveEpsilonSteadyStateMOCMAMain.cpp LocalitySensitiveEpsilonSteadyStateMOCMAMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/MOCMAMain.cpp MOCMAMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/MOCMASimple.cpp MOCMASimple "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/EpsilonMOCMAMain.cpp EpsilonMOCMAMain "EA/MOO" )
SHARK_ADD_EXAMPLE( EA/MOO/Experiment.cpp MooExperiment "EA/MOO" )

## SHARK_ADD_EXAMPLE( EA/SOO/XNES.cpp XNES "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/CMA.cpp CMAMain "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/CMASimple.cpp CMASimple "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/CMAProbes.cpp CMAProbes "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/CMSA.cpp CMSAMain "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/ElitistCMA.cpp ElitistCMAMain "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/ElitistCMASimple.cpp ElitistCMASimpleMain "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/OnePlusOneES.cpp OnePlusOneES "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/TSP.cpp TSP "EA/SOO" )
SHARK_ADD_EXAMPLE( EA/SOO/AckleyES.cpp AckleyES "EA/SOO" )

SHARK_ADD_EXAMPLE( Supervised/CVFolds.cpp CVFolds "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/CSvmWithThresholdConverter.cpp CSvmWithThresholdConverter "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/McSvm.cpp McSvm "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/McSvmLinear.cpp McSvmLinear "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/KernelRegression.cpp KernelRegression "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/KernelSelection.cpp KernelSelection "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/OneVersusOne.cpp OneVersusOne "Supervised" ) #partially working. Dataset issue

SHARK_ADD_EXAMPLE( Supervised/CSvmMaxLikelihoodMS.cpp CSvmMaxLikelihoodMS "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/CSvmGridSearchTutorial.cpp CSvmGridSearchTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/CSvmTutorial.cpp CSvmTutorial "Supervised" )

##SHARK_ADD_EXAMPLE( Supervised/OnlineSparseMcSvmExp.cpp OnlineSparseMcSvmExp "Supervised" )
##SHARK_ADD_EXAMPLE( Supervised/OnlineCSMcSvmExp.cpp OnlineCSMcSvmExp "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/SubrangeKernelTutorial.cpp SubrangeKernelTutorial "Supervised" )

SHARK_ADD_EXAMPLE( Supervised/KNNTutorial.cpp KNNTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/LDATutorial.cpp LDATutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/elmTutorial.cpp elmTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/kNN.cpp kNN "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/linearRegressionTutorial.cpp linearRegressionTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/LassoRegression.cpp LassoRegression "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/FFNNBasicTutorial.cpp FFNNBasicTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/FFNNSetStructureTutorial.cpp FFNNSetStructureTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/FFNNMultiClassCrossEntropy.cpp FFNNMultiClassCrossEntropy "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/FFNNMultiClassNormalizedTraining.cpp FFNNMultiClassNormalizedTraining "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/RFTutorial.cpp RFTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/CARTTutorial.cpp CARTTutorial "Supervised" )

#basic tutorials
SHARK_ADD_EXAMPLE( Supervised/quickstartTutorial.cpp quickstartTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/regressionTutorial.cpp regressionTutorial "Supervised" )
SHARK_ADD_EXAMPLE( Supervised/StoppingCriteria.cpp StoppingCriteriaTutorial "Supervised" )

#Statistics
SHARK_ADD_EXAMPLE( Statistics/StatisticsMain.cpp StatisticsMain "Statistiscs" )
SHARK_ADD_EXAMPLE( Statistics/Statistics.cpp Statistics "Statistiscs" )

#Unsupervisd
SHARK_ADD_EXAMPLE( Unsupervised/PCA.cpp PCA "Unsupervised"  )
SHARK_ADD_EXAMPLE( Unsupervised/PCATutorial.cpp PCATutorial "Unsupervised"  )
SHARK_ADD_EXAMPLE( Unsupervised/KMeansTutorial.cpp KMeansTutorial "Unsupervised"  )
SHARK_ADD_EXAMPLE( Unsupervised/BinaryRBM.cpp BinaryRBM "Unsupervised"  )
SHARK_ADD_EXAMPLE( Unsupervised/SparseAETutorial.cpp SparseAETutorial "Unsupervised"  )
SHARK_ADD_EXAMPLE( Unsupervised/HierarchicalClustering.cpp HierarchicalClustering "Unsupervised"  )
SHARK_ADD_EXAMPLE( Unsupervised/OneClassSvm.cpp OneClassSvm "Unsupervised"  )

INSTALL( DIRECTORY
	 "${CMAKE_CURRENT_SOURCE_DIR}/Supervised/data"
	 DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Supervised
	 PATTERN ".*" EXCLUDE
)
INSTALL( DIRECTORY
	 "${CMAKE_CURRENT_SOURCE_DIR}/Unsupervised/data"
	 DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/Unsupervised
	 PATTERN ".*" EXCLUDE
)

#####Automatic Generation of example CMakeLists.txt
CONFIGURE_FILE (
  "${CMAKE_CURRENT_SOURCE_DIR}/ExampleProject/CMakeLists.txt.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/ExampleProject/CMakeLists.txt"
  @ONLY
  )

INSTALL(
	FILES ${CMAKE_CURRENT_SOURCE_DIR}/ExampleProject/CMakeLists.txt
	DESTINATION ${SHARK_INSTALL_EXAMPLE_DIR}/ExampleProject/
)

=== include/CMakeLists.txt ===
SOURCE_GROUP( include/shark/Rng FILES shark/Rng/*.h )

SOURCE_GROUP( include/shark/LinAlg FILES shark/LinAlg/*.h )
SOURCE_GROUP( include/shark/LinAlg/Impl FILES shark/LinAlg/Impl/{*.h,*.inl} )
SOURCE_GROUP( include/shark/LinAlg/BLAS FILES shark/LinAlg/BLAS/*.h )
SOURCE_GROUP( include/shark/LinAlg/BLAS/Impl FILES shark/LinAlg/BLAS/Impl/{*.h,*.inl} )
SOURCE_GROUP( include/shark/LinAlg/BLAS/Impl/numeric_bindings FILES shark/LinAlg/BLAS/Impl/numeric_bindings/*.h )
SOURCE_GROUP( include/shark/LinAlg/BLAS/Impl/numeric_bindings/gotoblas FILES shark/LinAlg/BLAS/Impl/numeric_bindings/gotoblas/*.h )
SOURCE_GROUP( include/shark/LinAlg/BLAS/Impl/numeric_bindings/atlas FILES shark/LinAlg/BLAS/Impl/numeric_bindings/atlas/*.h )
SOURCE_GROUP( include/shark/LinAlg/BLAS/Impl/numeric_bindings/default FILES shark/LinAlg/BLAS/Impl/numeric_bindings/default/*.h )
SOURCE_GROUP( include/shark/LinAlg/BLAS/traits FILES shark/LinAlg/BLAS/traits/*.h )

SOURCE_GROUP( include/shark/Models FILES shark/Models/*.h )
SOURCE_GROUP( include/shark/Models/Clustering FILES shark/Models/Clustering/*.h )
SOURCE_GROUP( include/shark/Models/Trees FILES shark/Models/Trees/*.h )
SOURCE_GROUP( include/shark/Models/Kernels FILES shark/Models/Kernels/*.h )
SOURCE_GROUP( include/shark/Models/Impl FILES shark/Models/Kernels/Impl/{*.h,*.inl} )

SOURCE_GROUP( include/shark/ObjectiveFunctions FILES shark/ObjectiveFunctions/*.h )
SOURCE_GROUP( include/shark/ObjectiveFunctions/Loss FILES shark/ObjectiveFunctions/Loss/*.h )
SOURCE_GROUP( include/shark/ObjectiveFunctions/Benchmarks FILES shark/ObjectiveFunctions/Benchmarks/*.h )
SOURCE_GROUP( include/shark/ObjectiveFunctions/Benchmarks FILES shark/ObjectiveFunctions/Benchmarks/*.h )

SOURCE_GROUP( include/shark/Algorithms FILES shark/Algorithms/*.h )
SOURCE_GROUP( include/shark/Algorithms/Trainers FILES shark/Algorithms/Trainers/*.h )
SOURCE_GROUP( include/shark/Algorithms/LP FILES shark/Algorithms/LP/*.h )
SOURCE_GROUP( include/shark/Algorithms/QP FILES shark/Algorithms/QP/*.h )
SOURCE_GROUP( include/shark/Algorithms/NearestNeighbors FILES shark/Algorithms/NearestNeighbors/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch FILES shark/Algorithms/DirectSearch/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Experiments FILES shark/Algorithms/DirectSearch/Experiments/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Indicators FILES shark/Algorithms/DirectSearch/Indicators/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/CMA FILES shark/Algorithms/DirectSearch/CMA/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators FILES shark/Algorithms/DirectSearch/Operators/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Evaluation FILES shark/Algorithms/DirectSearch/Operators/Evaluation/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Initializers FILES shark/Algorithms/DirectSearch/Operators/Initializers/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Mutation FILES shark/Algorithms/DirectSearch/Operators/Mutation/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Mutation/CMA FILES shark/Algorithms/DirectSearch/Operators/Mutation/CMA/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Mutation/CMA FILES shark/Algorithms/DirectSearch/Operators/Mutation/CMA/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/ParameterUpdate FILES shark/Algorithms/DirectSearch/Operators/ParameterUpdate/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/ParameterUpdate/CMA FILES shark/Algorithms/DirectSearch/Operators/ParameterUpdate/CMA/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Recombination FILES shark/Algorithms/DirectSearch/Operators/Recombination/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Operators/Selection FILES shark/Algorithms/DirectSearch/Operators/Selection/*.h )
SOURCE_GROUP( include/shark/Algorithms/DirectSearch/Traits FILES shark/Algorithms/DirectSearch/Traits/*.h )

SOURCE_GROUP( include/shark/Data FILES shark/Data/*.h )
SOURCE_GROUP( include/shark/Data/Impl FILES shark/Data/Impl/*.h )

SOURCE_GROUP( include/shark/Core FILES shark/Core/*.h )
SOURCE_GROUP( include/shark/Core/LogFormatters FILES shark/Core/LogFormatters/*.h )
SOURCE_GROUP( include/shark/Core/LogHandlers FILES shark/Core/LogHandlers/*.h )
SOURCE_GROUP( include/shark/Core/Renderers FILES shark/Core/Renderers/*.h )
SOURCE_GROUP( include/shark/Core/SearchSpaces FILES shark/Core/SearchSpaces/*.h )
SOURCE_GROUP( include/shark/Core/Traits FILES shark/Core/Traits/*.h )
SOURCE_GROUP( include/shark/Core/utility FILES shark/Core/utility/*.h )

SOURCE_GROUP( include/shark/Unsupervised FILES shark/Unsupervised/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/ FILES shark/Unsupervised/RBM/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/Impl FILES shark/Unsupervised/RBM/Impl/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/Problems FILES shark/Unsupervised/RBM/Problems/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/NeuronLayers FILES shark/Unsupervised/RBM/NeuronLayers/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/StateSpaces FILES shark/Unsupervised/RBM/StateSpaces/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/GradientApproximations FILES shark/Unsupervised/RBM/GradientApproximations/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/GradientApproximations/Impl FILES shark/Unsupervised/RBM/GradientApproximations/Impl/*.h )
SOURCE_GROUP( include/shark/Unsupervised/RBM/Sampling FILES shark/Unsupervised/RBM/Sampling/*.h )

#SOURCE_GROUP( include/shark/Fuzzy FILES shark/Fuzzy/*.h )
#SOURCE_GROUP( include/shark/FCL FILES shark/FCL/*.h )
#SOURCE_GROUP( include/shark/FuzzySets FILES shark/FuzzySets/*.h )
#SOURCE_GROUP( include/shark/LinguisticTerms FILES shark/LinguisticTerms/*.h )


INSTALL( DIRECTORY
	 ${CMAKE_CURRENT_SOURCE_DIR}/shark
	 DESTINATION DESTINATION ${SHARK_INSTALL_INCLUDE_DIR}
	 PATTERN ".*" EXCLUDE
)

=== src/CMakeLists.txt ===

FILE( GLOB SRCS
	Models/*.cpp
	ObjectiveFunctions/*.cpp
	ObjectiveFunctions/Loss/*.cpp
	Data/*.cpp
	Algorithms/*.cpp
	Algorithms/DirectSearch/*.cpp
	Algorithms/GradientDescent/*.cpp
	Fuzzy/*.cpp
)

SOURCE_GROUP( src/Models FILES Models/*.cpp )
SOURCE_GROUP( src/ObjectiveFunctions FILES ObjectiveFunctions/*.cpp )
SOURCE_GROUP( src/Algorithms FILES Algorithms/*.cpp )
SOURCE_GROUP( src/Fuzzy FILES Fuzzy/*.cpp )


#####################################################################
#                       Library setup                               #
#####################################################################

IF( WIN32 )
    ADD_LIBRARY( shark ${SRCS} )
    SET_TARGET_PROPERTIES( shark PROPERTIES DEBUG_PREFIX ../ )
    SET_TARGET_PROPERTIES( shark PROPERTIES DEBUG_POSTFIX _debug )
ELSE( WIN32 )
      ADD_LIBRARY( shark ${LIBRARY_FLAGS} ${SRCS} )
      SET_TARGET_PROPERTIES( shark PROPERTIES DEBUG_POSTFIX _debug )
ENDIF( WIN32 )

TARGET_LINK_LIBRARIES( shark ${LINK_LIBRARIES} )

ADD_EXECUTABLE( Version Core/Version.cpp )
TARGET_LINK_LIBRARIES( Version ${LINK_LIBRARIES} )

#####################################################################
#                       Install the library                         #
#####################################################################
SET_TARGET_PROPERTIES( shark PROPERTIES
	VERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.{SHARK_VERSION_PATCH}
	SOVERSION ${SHARK_VERSION_MAJOR}.${SHARK_VERSION_MINOR}.{SHARK_VERSION_PATCH}
)

INSTALL( TARGETS shark
	EXPORT SharkTargets
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib
)
INSTALL(
	TARGETS Version
	EXPORT SharkTargets
	RUNTIME DESTINATION bin
)

=== debian/changelog ===
libshark (3.0.11) oneiric; urgency=low
	
  * Added build-dependency on python-pyparsing
  * Added automatic building and installation of doxylink
  * Added build-dependency on graphviz.
  * Added automatic installation of sphinxcontrib-doxylink
  * Added installation of documentation.
  * Adjusted the section to science.
  * Added doxygen, texlive and python-sphinx to build dependencies.
  * Removed kernel function unit test.
  * Added cmake as build dependency.
  * Adjusted distro series in debian/changelog to oneiric.
  * Adjusted distro series in debian/changelog.
  * Initial release.

 -- Thomas Voß <thomas.voss@rub.de>  Wed, 09 Nov 2011 08:53:35 +0100

=== debian/control ===
Source: libshark
Maintainer: Thomas Voß <thomas.voss@rub.de>
Section: science
Priority: optional
Standards-Version: 3.0.0
Build-Depends: graphviz, python-pip, doxygen, texlive-full, python-pyparsing, python-sphinx, cmake, libboost1.46-all-dev, debhelper (>= 7.3.8)
Homepage: http://shark-project.sourceforge.net

Package: libshark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shark Machine Learning Library
 SHARK is a modular C++ library for the design and
 optimization of adaptive systems. It provides methods for linear and
 nonlinear optimization, in particular evolutionary and gradient-based
 algorithms, kernel-based learning algorithms and neural networks, and
 various other machine learning techniques. SHARK serves as a toolbox
 to support real world applications as well as research indifferent
 domains of computational intelligence and machine learning. The
 sources are compatible with the following platforms: Windows, Solaris,
 MacOS X, and Linux.
